// FunctionalIIC v.0.7-1. 20210720. by ken woo. freely treatments.

#include"functionaliic.h"

SRAM_ACES void cb_test(){static unsigned u=0; printf("\r\n[MasterCb]\r\n"); if (u++>15){sSton::the_rt_all_bytes()=1; u=0;}}
SRAM_ACES void scb_testr(unsigned x){printf("\r\n[SlaveCbRead, %X]\r\n", x);}
SRAM_ACES void scb_testw(unsigned &x){static unsigned u=0xA1; x=u++; printf("\r\n[SlaveCbWrite, %X]\r\n", x);}
SRAM_ACES void cb_start_n8(){printf("master to addr 8 started.\r\n");}
SRAM_ACES void cb_stop_n8(){printf("master to addr 8 stopped.\r\n");}


unsigned char mybuf[100];
cIIC a, b, art, brt, d, e, drt, ert;
cIicSlave sa, sb, sart, sbrt, sd, se, sdrt, sert;




void setup(){
    Serial.begin(115200);
    while (!Serial) delay(10);


    a.Suspend();
    a.Config(1, 5, mybuf, true, false); // read. addr=1, read 5 bytes, directly stop, non-relatime.

    b.Suspend();
    b.Config(2, mybuf, 1, true, false); // write. addr=2, write 1 bytes, directly stop, non-realtime.

    art.Suspend();
    art.Config(3, 10, mybuf, false, true); // read rt. addr=3, read 10 bytes, repeat-start, realtime.
    art.RtConfig(cIIC::IIC_OPT_RT_READ, cb_test, cb_test); // read rt

    brt.Suspend();
    brt.Config(4, mybuf, 7, false, true); // write rt. addr=4, write 7 bytes, repeat-start, realtime.
    brt.RtConfig(cIIC::IIC_OPT_RT_WRITE, cb_test, cb_test); // write rt

    d.Suspend();
    d.Config(5, 1, 1, mybuf, mybuf, cIIC::IIC_OPT_R_THEN_W); // rw. addr=5, read 1 then write 1, repeat-start, non-realtime.

    // wr. addr=6, write 1 then read 8, directly stop, non-realtime.
    e.Suspend();
    e.Config(6, 8, 1, mybuf, mybuf, (cIIC::eIIC_OPTS)(cIIC::IIC_OPT_W_THEN_R|cIIC::IIC_OPT_DIRECT_STOP));

    // rw rt. addr=7, read 1 then write 1, repeat-start, realtime.
    drt.Suspend();
    drt.Config(7, 1, 1, mybuf, mybuf, cIIC::IIC_OPT_R_THEN_W, true);
    drt.RtConfig(cIIC::IIC_OPT_RT_TRANSFER, cb_test, cb_test); // rw rt

    // wr rt. addr=8, write 8 then read 1, repeat-start, realtime write, non-realtime read.
    ert.Suspend();
    ert.Config(8, 1, 8, mybuf, mybuf, cIIC::IIC_OPT_W_THEN_R, true);
    ert.RtConfig(cIIC::IIC_OPT_RT_WRITE, cb_test, cb_test); // wr rt
    ert.SetCb(cb_start_n8, cb_stop_n8);

    sa.Config(1, scb_testr, scb_testw); // a slave with addr=1 generated.
    sb.Config(2, scb_testr, scb_testw);
    sart.Config(3, scb_testr, scb_testw);
    sbrt.Config(4, scb_testr, scb_testw);
    sd.Config(5, scb_testr, scb_testw);
    se.Config(6, scb_testr, scb_testw);
    sdrt.Config(7, scb_testr, scb_testw);
    sert.Config(8, scb_testr, scb_testw);

    SetHwTimer1(wrap_isr); // this is timer triggered setup.
}

void loop(){
    //cIIC::isr_iicproc(); // this is polling.

    static unsigned xx=0;
    if (xx++==429496){
        printf("\r\n---------------------------\r\n");
        a.Resume();b.Resume();art.Resume();brt.Resume();d.Resume();e.Resume();drt.Resume();ert.Resume();
        a.RepRun();b.RepRun();art.RepRun();brt.RepRun();d.RepRun();e.RepRun();drt.RepRun();ert.RepRun();
    }
    if (xx==429496*3){
        a.PrintStatus();b.PrintStatus();art.PrintStatus();brt.PrintStatus();
        d.PrintStatus();e.PrintStatus();drt.PrintStatus();ert.PrintStatus();
    }

    // so, observed that if speedup, bit-rate is about 100k/s. and of course, all failed,
    // which is because speedup masters can not run with SimulatedSlaves whom will nack all.
    if (xx==429496*8){cIIC::SpeedUp(); ert.AutoRun();}
    if (xx==429496*9){while (!cIIC::SpeedNormal()) delay(1);}

    if (xx==429496*10){ert.ManualRun();}
    if (xx>=429496*11){
        xx--;
        ert.RepRun();
        delay(2000); // this delay let loop halt on 2 seconds, however not affects iic processing if timer triggered.
    }
}
